﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Praktikum_2
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            Windenergieanlage maximal = new Maximum(127.0);
            Windenergieanlage meineWEA = new E126EP4();

            //// kleiner Check, ob Rayleigh stimmt:
            //double s = 0.0;
            //double e = 0.0;
            //for (double x = 0.0; x < 600.0; x += 0.0001)
            //{
            //    double p = Windenergieanlage.Rayleigh(6.0, x+0.0001) - Windenergieanlage.Rayleigh(6.0, x);
            //    s += p;
            //    e += x*p;
            //}
            //// s muss nun 1.0 sein und e muss nun 6.0 sein (bis auf Rundungsfehler).

            textBoxJahresenergieertrag.Text = Math.Round(meineWEA.BestimmeJahresenergieertrag_kWh(9.0) / 1000.0) + " MWh";

            const int schritte = 50;
            const double maxWindgeschwindigkeit = 35.0;
            Polyline polyLeistung = new Polyline();
            Polyline polyLeistungsbeiwert = new Polyline();
            for (int i = 0; i < schritte; i++)
            {
                double x = zeichenflächeLeistung.Width * i / schritte;
                double v = maxWindgeschwindigkeit * i / schritte;
                double p = meineWEA.BestimmeLeistung_kW(v);
                double cp = p / (maximal.BestimmeLeistung_kW(v) + 1e-42); // ... + 1e-42, damit wir nicht durch 0 teilen!
                polyLeistung.Points.Add(new Point(x, (1.0 - 0.0001 * p) * zeichenflächeLeistung.Height));
                polyLeistungsbeiwert.Points.Add(new Point(x, (1.0 - cp) * zeichenflächeLeistungsbeiwert.Height));
            }
            polyLeistung.Stroke = Brushes.Magenta;
            zeichenflächeLeistung.Children.Add(polyLeistung);
            polyLeistungsbeiwert.Stroke = Brushes.Black;
            zeichenflächeLeistungsbeiwert.Children.Add(polyLeistungsbeiwert);
        }
    }
}
